Index: /trunk/src/bp-core/bp-core-avatars.php
===================================================================
--- /trunk/src/bp-core/bp-core-avatars.php	(revision 10011)
+++ /trunk/src/bp-core/bp-core-avatars.php	(revision 10012)
@@ -108,5 +108,5 @@
  *    add_filter( 'bp_core_fetch_avatar_no_grav', '__return_true' );
  *
- * @param array $args {
+ * @param array|string $args {
  *     An array of arguments. All arguments are technically optional; some
  *     will, if not provided, be auto-detected by bp_core_fetch_avatar(). This
@@ -114,68 +114,69 @@
  *     arguments.
  *
- *     @type int|bool $item_id The numeric ID of the item for which you're
- *           requesting an avatar (eg, a user ID). If no 'item_id' is present,
- *           the function attempts to infer an ID from the 'object' + the
- *           current context: if 'object' is 'user' and the current page is a
- *           user page, 'item_id' will default to the displayed user ID; if
- *           'group' and on a group page, to the current group ID; if 'blog',
- *           to the current blog's ID. If no 'item_id' can be determined in
- *           this way, the function returns false. Default: false.
- *     @type string $object The kind of object for which you're getting an
- *           avatar. BuddyPress natively supports three options: 'user',
- *           'group', 'blog'; a plugin may register more.  Default: 'user'.
- *     @type string $type When a new avatar is uploaded to BP, 'thumb' and
- *           'full' versions are saved. This parameter specifies whether you'd
- *           like the 'full' or smaller 'thumb' avatar. Default: 'thumb'.
+ *     @type int|bool    $item_id    The numeric ID of the item for which you're requesting
+ *                                   an avatar (eg, a user ID). If no 'item_id' is present,
+ *                                   the function attempts to infer an ID from the 'object' + the
+ *                                   current context: if 'object' is 'user' and the current page is a
+ *                                   user page, 'item_id' will default to the displayed user ID; if
+ *                                   'group' and on a group page, to the current group ID; if 'blog',
+ *                                   to the current blog's ID. If no 'item_id' can be determined in
+ *                                   this way, the function returns false. Default: false.
+ *     @type string      $object     The kind of object for which you're getting an
+ *                                   avatar. BuddyPress natively supports three options: 'user',
+ *                                   'group', 'blog'; a plugin may register more.  Default: 'user'.
+ *     @type string      $type       When a new avatar is uploaded to BP, 'thumb' and
+ *                                   'full' versions are saved. This parameter specifies whether you'd
+ *                                   like the 'full' or smaller 'thumb' avatar. Default: 'thumb'.
  *     @type string|bool $avatar_dir The name of the subdirectory where the
- *           requested avatar should be found. If no value is passed,
- *           'avatar_dir' is inferred from 'object': 'user' becomes 'avatars',
- *           'group' becomes 'group-avatars', 'blog' becomes 'blog-avatars'.
- *           Remember that this string denotes a subdirectory of BP's main
- *           avatar directory (usually based on {@link wp_upload_dir()}); it's a
- *           string like 'group-avatars' rather than the full directory path.
- *           Generally, it'll only be necessary to override the default value if
- *           storing avatars in a non-default location. Defaults to false
- *           (auto-detected).
- *     @type int|bool $width Requested avatar width. The unit is px. This value
- *           is used to build the 'width' attribute for the <img> element. If
- *           no value is passed, BP uses the global avatar width for this
- *           avatar type. Default: false (auto-detected).
- *     @type int|bool $height Requested avatar height. The unit is px. This
- *           value is used to build the 'height' attribute for the <img>
- *           element. If no value is passed, BP uses the global avatar height
- *           for this avatar type. Default: false (auto-detected).
- *     @type string $class The CSS class for the <img> element. Note that BP
- *           uses the 'avatar' class fairly extensively in its default styling,
- *           so if you plan to pass a custom value, consider appending it to
- *           'avatar' (eg 'avatar foo') rather than replacing it altogether.
- *           Default: 'avatar'.
- *     @type string|bool $css_id The CSS id for the <img> element.
- *           Default: false.
- *     @type string $title The title attribute for the <img> element.
- *           Default: false.
- *     @type string $alt The alt attribute for the <img> element. In BP, this
- *           value is generally passed by the wrapper functions, where the data
- *           necessary for concatenating the string is at hand; see
- *           {@link bp_get_activity_avatar()} for an example. Default: ''.
- *     @type string|bool $email An email to use in Gravatar queries. Unless
- *           otherwise configured, BP uses Gravatar as a fallback for avatars
- *           that are not provided locally. Gravatar's API requires using a hash
- *           of the user's email address; this argument provides it. If not
- *           provided, the function will infer it: for users, by getting the
- *           user's email from the database, for groups/blogs, by concatenating
- *           "{$item_id}-{$object}@{bp_get_root_domain()}". The user query adds
- *           overhead, so it's recommended that wrapper functions provide a
- *           value for 'email' when querying user IDs. Default: false.
- *     @type bool $no_grav Whether to disable the default Gravatar fallback.
- *           By default, BP will fall back on Gravatar when it cannot find a
- *           local avatar. In some cases, this may be undesirable, in which
- *           case 'no_grav' should be set to true. To disable Gravatar
- *           fallbacks globally, see the 'bp_core_fetch_avatar_no_grav' filter.
- *           Default: false.
- *     @type bool $html Whether to return an <img> HTML element, vs a raw URL
- *           to an avatar. If false, <img>-specific arguments (like 'css_id')
- *           will be ignored. Default: true.
+ *                                   requested avatar should be found. If no value is passed,
+ *                                   'avatar_dir' is inferred from 'object': 'user' becomes 'avatars',
+ *                                   'group' becomes 'group-avatars', 'blog' becomes 'blog-avatars'.
+ *                                   Remember that this string denotes a subdirectory of BP's main
+ *                                   avatar directory (usually based on {@link wp_upload_dir()}); it's a
+ *                                   string like 'group-avatars' rather than the full directory path.
+ *                                   Generally, it'll only be necessary to override the default value if
+ *                                   storing avatars in a non-default location. Defaults to false
+ *                                   (auto-detected).
+ *     @type int|bool    $width      Requested avatar width. The unit is px. This value
+ *                                   is used to build the 'width' attribute for the <img> element. If
+ *                                   no value is passed, BP uses the global avatar width for this
+ *                                   avatar type. Default: false (auto-detected).
+ *     @type int|bool    $height     Requested avatar height. The unit is px. This
+ *                                   value is used to build the 'height' attribute for the <img>
+ *                                   element. If no value is passed, BP uses the global avatar height
+ *                                   for this avatar type. Default: false (auto-detected).
+ *     @type string      $class      The CSS class for the <img> element. Note that BP
+ *                                   uses the 'avatar' class fairly extensively in its default styling,
+ *                                   so if you plan to pass a custom value, consider appending it to
+ *                                   'avatar' (eg 'avatar foo') rather than replacing it altogether.
+ *                                   Default: 'avatar'.
+ *     @type string|bool $css_id     The CSS id for the <img> element.
+ *                                   Default: false.
+ *     @type string      $title      The title attribute for the <img> element.
+ *                                   Default: false.
+ *     @type string      $alt        The alt attribute for the <img> element. In BP, this
+ *                                   value is generally passed by the wrapper functions, where the data
+ *                                   necessary for concatenating the string is at hand; see
+ *                                   {@link bp_get_activity_avatar()} for an example. Default: ''.
+ *     @type string|bool $email      An email to use in Gravatar queries. Unless
+ *                                   otherwise configured, BP uses Gravatar as a fallback for avatars
+ *                                   that are not provided locally. Gravatar's API requires using a hash
+ *                                   of the user's email address; this argument provides it. If not
+ *                                   provided, the function will infer it: for users, by getting the
+ *                                   user's email from the database, for groups/blogs, by concatenating
+ *                                   "{$item_id}-{$object}@{bp_get_root_domain()}". The user query adds
+ *                                   overhead, so it's recommended that wrapper functions provide a
+ *                                   value for 'email' when querying user IDs. Default: false.
+ *     @type bool       $no_grav     Whether to disable the default Gravatar fallback.
+ *                                   By default, BP will fall back on Gravatar when it cannot find a
+ *                                   local avatar. In some cases, this may be undesirable, in which
+ *                                   case 'no_grav' should be set to true. To disable Gravatar
+ *                                   fallbacks globally, see the 'bp_core_fetch_avatar_no_grav' filter.
+ *                                   Default: false.
+ *     @type bool       $html        Whether to return an <img> HTML element, vs a raw URL
+ *                                   to an avatar. If false, <img>-specific arguments (like 'css_id')
+ *                                   will be ignored. Default: true.
  * }
+ *
  * @return string Formatted HTML <img> element, or raw avatar URL based on $html arg.
  */
@@ -530,5 +531,5 @@
 				return apply_filters( 'bp_core_fetch_avatar', '<img src="' . $avatar_url . '"' . $html_class . $html_css_id  . $html_width . $html_height . $html_alt . $html_title . ' />', $params, $params['item_id'], $params['avatar_dir'], $html_css_id, $html_width, $html_height, $avatar_folder_url, $avatar_folder_dir );
 
-			// ...or only the URL
+				// ...or only the URL
 			} else {
 
@@ -611,5 +612,5 @@
 		}
 
-	// No avatar was found, and we've been told not to use a gravatar.
+		// No avatar was found, and we've been told not to use a gravatar.
 	} else {
 
@@ -641,5 +642,5 @@
  * Delete an existing avatar.
  *
- * @param array $args {
+ * @param array|string $args {
  *     Array of function parameters.
  *     @type bool|int $item_id ID of the item whose avatar you're deleting.
@@ -721,10 +722,10 @@
 
 /**
- * Ajax delete an avatar for a given object and item id
- *
- * @since  BuddyPress (2.3.0)
- *
- * @return  string a json object containing success data if the avatar was deleted
- *                 error message otherwise
+ * Ajax delete an avatar for a given object and item id.
+ *
+ * @since BuddyPress (2.3.0)
+ *
+ * @return string|null A json object containing success data if the avatar was deleted
+ *                     error message otherwise.
  */
 function bp_avatar_ajax_delete() {
@@ -855,10 +856,10 @@
 
 /**
- * Ajax upload an avatar
+ * Ajax upload an avatar.
  *
  * @since BuddyPress (2.3.0)
  *
- * @return  string a json object containing success data if the upload succeeded
- *                 error message otherwise
+ * @return  string|null A json object containing success data if the upload succeeded
+ *                      error message otherwise.
  */
 function bp_avatar_ajax_upload() {
@@ -923,9 +924,9 @@
 	} else {
 		/**
-		 * Filter here to deal with other components
+		 * Filter here to deal with other components.
 		 *
 		 * @since BuddyPress (2.3.0)
 		 *
-		 * @var array $bp_params the BuddyPress Ajax parameters
+		 * @var array $bp_params the BuddyPress Ajax parameters.
 		 */
 		$bp_params = apply_filters( 'bp_core_avatar_ajax_upload_params', $bp_params );
@@ -1008,6 +1009,7 @@
  * @since BuddyPress (2.3.0)
  *
- * @param string $data base64 encoded image.
- * @param int $item_id.
+ * @param string $data     Base64 encoded image.
+ * @param int    $item_id.
+  *
  * @return bool True on success, false on failure.
  */
@@ -1026,4 +1028,14 @@
 	}
 
+	/**
+	 * Filters the Avatar folder directory.
+	 *
+	 * @since BuddyPress (2.3.0)
+	 *
+	 * @param string $avatar_dir Directory for storing avatars.
+	 * @param int    $item_id    ID of the item being acted on.
+	 * @param string $value      Avatar type.
+	 * @param string $value      Avatars word.
+	 */
 	$avatar_folder_dir = apply_filters( 'bp_core_avatar_folder_dir', $avatar_dir . '/' . $item_id, $item_id, 'user', 'avatars' );
 
@@ -1043,4 +1055,9 @@
 		$crop_args = array( 'item_id' => $item_id, 'original_file' => $avatar_to_crop, 'crop_x' => 0, 'crop_y' => 0 );
 
+		/**
+		 * Fires if the new avatar was successfully captured.
+		 *
+		 * @since BuddyPress (2.3.0)
+		 */
 		do_action( 'xprofile_avatar_uploaded' );
 
@@ -1064,20 +1081,22 @@
  *  crop_y - The vertical starting point of the crop
  *
- * @param array $args {
+ * @param array|string $args {
  *     Array of function parameters.
- *     @type string $object Object type of the item whose avatar you're
- *           handling. 'user', 'group', 'blog', or custom. Default: 'user'.
- *     @type string $avatar_dir Subdirectory where avatar should be stored.
- *           Default: 'avatars'.
- *     @type bool|int $item_id ID of the item that the avatar belongs to.
- *     @type bool|string $original_file Absolute path to the original avatar
- *           file.
- *     @type int $crop_w Crop width. Default: the global 'full' avatar width,
- *           as retrieved by bp_core_avatar_full_width().
- *     @type int $crop_h Crop height. Default: the global 'full' avatar height,
- *           as retrieved by bp_core_avatar_full_height().
- *     @type int $crop_x The horizontal starting point of the crop. Default: 0.
- *     @type int $crop_y The vertical starting point of the crop. Default: 0.
+ *
+ *     @type string      $object        Object type of the item whose avatar you're
+ *                                      handling. 'user', 'group', 'blog', or custom.
+ *                                      Default: 'user'.
+ *     @type string      $avatar_dir    Subdirectory where avatar should be stored.
+ *                                      Default: 'avatars'.
+ *     @type bool|int    $item_id       ID of the item that the avatar belongs to.
+ *     @type bool|string $original_file Absolute path to the original avatar file.
+ *     @type int         $crop_w        Crop width. Default: the global 'full' avatar width,
+ *                                      as retrieved by bp_core_avatar_full_width().
+ *     @type int         $crop_h        Crop height. Default: the global 'full' avatar height,
+ *                                      as retrieved by bp_core_avatar_full_height().
+ *     @type int         $crop_x        The horizontal starting point of the crop. Default: 0.
+ *     @type int         $crop_y        The vertical starting point of the crop. Default: 0.
  * }
+ *
  * @return bool True on success, false on failure.
  */
@@ -1103,5 +1122,5 @@
 	 *
 	 * @param bool  $value Whether or not to crop.
-	 * @param array $r     Array of parsed arguments for function
+	 * @param array $r     Array of parsed arguments for function.
 	 */
 	if ( ! apply_filters( 'bp_core_pre_avatar_handle_crop', true, $r ) ) {
@@ -1122,10 +1141,10 @@
 
 /**
- * Ajax set an avatar for a given object and item id
+ * Ajax set an avatar for a given object and item id.
  *
  * @since BuddyPress (2.3.0)
  *
- * @return  string a json object containing success data if the crop/capture succeeded
- *                 error message otherwise
+ * @return  string|null A json object containing success data if the crop/capture succeeded
+ *                      error message otherwise.
  */
 function bp_avatar_ajax_set() {
@@ -1241,9 +1260,10 @@
  * Filters 'get_avatar'.
  *
- * @param string $avatar The avatar path passed to 'get_avatar'.
- * @param int|string|object $user A user ID, email address, or comment object.
- * @param int $size Size of the avatar image ('thumb' or 'full').
- * @param string $default URL to a default image to use if no avatar is available.
- * @param string $alt Alternate text to use in image tag. Default: ''.
+ * @param string            $avatar  The avatar path passed to 'get_avatar'.
+ * @param int|string|object $user    A user ID, email address, or comment object.
+ * @param int               $size    Size of the avatar image ('thumb' or 'full').
+ * @param string            $default URL to a default image to use if no avatar is available.
+ * @param string            $alt     Alternate text to use in image tag. Default: ''.
+ *
  * @return string BP avatar path, if found; else the original avatar path.
  */
@@ -1307,4 +1327,5 @@
  *
  * @param array $file The $_FILES array.
+ *
  * @return bool True if no errors are found. False if there are errors.
  */
@@ -1320,4 +1341,5 @@
  *
  * @param array $file The $_FILES array.
+ *
  * @return bool True if the avatar is under the size limit, otherwise false.
  */
@@ -1330,7 +1352,7 @@
 
 /**
- * Get allowed avatar types
- *
- * @since  BuddyPress (2.3.0)
+ * Get allowed avatar types.
+ *
+ * @since BuddyPress (2.3.0)
  */
 function bp_core_get_allowed_avatar_types() {
@@ -1338,9 +1360,9 @@
 
 	/**
- 	 * Use this filter to restrict image types
+ 	 * Filters the list of allowed image types.
  	 *
  	 * @since BuddyPress (2.3.0)
  	 *
- 	 * @param array list of image types
+ 	 * @param array $allowed_types List of image types.
  	 */
  	$avatar_types = (array) apply_filters( 'bp_core_get_allowed_avatar_types', $allowed_types );
@@ -1356,7 +1378,7 @@
 
 /**
- * Get allowed avatar mime types
- *
- * @since  BuddyPress (2.3.0)
+ * Get allowed avatar mime types.
+ *
+ * @since BuddyPress (2.3.0)
  */
 function bp_core_get_allowed_avatar_mimes() {
@@ -1382,4 +1404,5 @@
  *
  * @param array $file The $_FILES array.
+ *
  * @return bool True if the file extension is permitted, otherwise false.
  */
@@ -1399,6 +1422,7 @@
  * @since BuddyPress (1.8.0)
  *
- * @param string $type The variable we want to return from the $bp->avatars
- *        object. Only 'upload_path' and 'url' are supported. Default: 'upload_path'.
+ * @param string $type The variable we want to return from the $bp->avatars object.
+ *                     Only 'upload_path' and 'url' are supported. Default: 'upload_path'.
+ *
  * @return string The avatar upload directory path.
  */
@@ -1474,5 +1498,5 @@
  * Get the absolute upload path for the WP installation.
  *
- * @uses bp_core_get_upload_dir() To get upload directory info
+ * @uses bp_core_get_upload_dir() To get upload directory info.
  *
  * @return string Absolute path to WP upload directory.
@@ -1515,4 +1539,5 @@
  *
  * @param int $user_id ID of the user whose avatar is being checked.
+ *
  * @return bool True if the user has uploaded a local avatar. Otherwise false.
  */
@@ -1542,9 +1567,10 @@
  * @since BuddyPress (1.5.0)
  *
- * @param string $type Dimension type you're fetching dimensions for. 'thumb'
- *        or 'full'. Default: 'thumb'.
+ * @param string $type   Dimension type you're fetching dimensions for. 'thumb'
+ *                       or 'full'. Default: 'thumb'.
  * @param string $h_or_w Which dimension is being fetched. 'height' or 'width'.
- *        Default: 'height'.
- * @return int $dim The dimension.
+ *                       Default: 'height'.
+ *
+ * @return int|bool $dim The dimension.
  */
 function bp_core_avatar_dimension( $type = 'thumb', $h_or_w = 'height' ) {
@@ -1557,7 +1583,7 @@
 	 * @since BuddyPress (1.5.0)
 	 *
-	 * @param int    $dim    Dimension setting for the type.
-	 * @param string $type   The type of avatar whose dimensions are requested. Default 'thumb'.
-	 * @param string $h_or_w The dimension parameter being requested. Default 'height'.
+	 * @param int|bool $dim    Dimension setting for the type.
+	 * @param string   $type   The type of avatar whose dimensions are requested. Default 'thumb'.
+	 * @param string   $h_or_w The dimension parameter being requested. Default 'height'.
 	 */
 	return apply_filters( 'bp_core_avatar_dimension', $dim, $type, $h_or_w );
@@ -1603,5 +1629,5 @@
 
 /**
- * Get the 'full' avatar width setting
+ * Get the 'full' avatar width setting.
  *
  * @since BuddyPress (1.5.0)
@@ -1683,7 +1709,8 @@
  * @since BuddyPress (1.5.0)
  *
- * @param string $type 'local' if the fallback should be the locally-hosted
- *        version of the mystery-man, 'gravatar' if the fallback should be
- *        Gravatar's version. Default: 'gravatar'.
+ * @param string $type 'local' if the fallback should be the locally-hosted version
+ *                     of the mystery-man, 'gravatar' if the fallback should be
+ *                     Gravatar's version. Default: 'gravatar'.
+ *
  * @return string The URL of the default avatar.
  */
@@ -1720,7 +1747,8 @@
  * @since BuddyPress (1.5.0)
  *
- * @param string $type 'local' if the fallback should be the locally-hosted
- *        version of the mystery-man, 'gravatar' if the fallback should be
- *        Gravatar's version. Default: 'gravatar'.
+ * @param string $type 'local' if the fallback should be the locally-hosted version
+ *                     of the mystery-man, 'gravatar' if the fallback should be
+ *                     Gravatar's version. Default: 'gravatar'.
+ *
  * @return string The URL of the default avatar thumb.
  */
@@ -1750,13 +1778,14 @@
 
 /**
- * Reset the week parameter of the WordPress main query if needed
+ * Reset the week parameter of the WordPress main query if needed.
  *
  * When cropping an avatar, a $_POST['w'] var is sent, setting the 'week'
  * parameter of the WordPress main query to this posted var. To avoid
- * notices, we need to make sure this 'week' query var is reset to 0
+ * notices, we need to make sure this 'week' query var is reset to 0.
  *
  * @since  BuddyPress (2.2.0)
  *
- * @param  WP_Query $posts_query the main query object
+ * @param  WP_Query|null $posts_query the main query object.
+ *
  * @uses   bp_is_group_create()
  * @uses   bp_is_group_admin_page()
@@ -1793,9 +1822,9 @@
 
 /**
- * Checks whether Avatar UI should be loaded
+ * Checks whether Avatar UI should be loaded.
  *
  * @since  BuddyPress (2.3.0)
  *
- * @return bool True if Avatar UI should load, false otherwise
+ * @return bool True if Avatar UI should load, false otherwise.
  */
 function bp_avatar_is_front_edit() {
@@ -1829,5 +1858,5 @@
 	 * @since  BuddyPress (2.3.0)
 	 *
-	 * @var  bool whether to load the Avatar UI
+	 * @param bool whether to load the Avatar UI.
 	 */
 	return apply_filters( 'bp_avatar_is_front_edit', $retval );
@@ -1835,5 +1864,5 @@
 
 /**
- * Checks whether the Webcam Avatar UI part should be loaded
+ * Checks whether the Webcam Avatar UI part should be loaded.
  *
  * @since  BuddyPress (2.3.0)
@@ -1867,7 +1896,7 @@
 	 * by returning false.
 	 *
-	 * @since  BuddyPress (2.3.0)
-	 *
-	 * @var  bool whether to load Webcam Avatar UI part
+	 * @since BuddyPress (2.3.0)
+	 *
+	 * @param bool whether to load Webcam Avatar UI part.
 	 */
 	return apply_filters( 'bp_avatar_use_webcam', true );
@@ -1875,5 +1904,5 @@
 
 /**
- * Template function to load the Avatar UI javascript templates
+ * Template function to load the Avatar UI javascript templates.
  *
  * @since  BuddyPress (2.3.0)
@@ -1888,5 +1917,5 @@
 
 /**
- * Trick to check if the theme's BuddyPress templates are up to date
+ * Trick to check if the theme's BuddyPress templates are up to date.
  *
  * If the "avatar templates" are not including the new template tag, this will
